Index: LMDZ4/trunk/libf/phylmd/ajsec.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/ajsec.F	(revision 868)
+++ LMDZ4/trunk/libf/phylmd/ajsec.F	(revision 878)
@@ -2,5 +2,159 @@
 ! $Header$
 !
-      SUBROUTINE ajsec(paprs, pplay, t,q, d_t,d_q)
+      SUBROUTINE ajsec(paprs, pplay, t,q,limbas,d_t,d_q)
+      USE dimphy
+      IMPLICIT none
+c======================================================================
+c Auteur(s): Z.X. Li (LMD/CNRS) date: 19930818
+c Objet: ajustement sec (adaptation du GCM du LMD)
+c======================================================================
+c Arguments:
+c t-------input-R- Temperature
+c
+c d_t-----output-R-Incrementation de la temperature
+c======================================================================
+cym#include "dimensions.h"
+cym#include "dimphy.h"
+#include "YOMCST.h"
+      REAL paprs(klon,klev+1), pplay(klon,klev)
+      REAL t(klon,klev), q(klon,klev)
+      REAL d_t(klon,klev), d_q(klon,klev)
+c
+      INTEGER limbas(klon), limhau ! les couches a ajuster
+c
+      LOGICAL mixq
+ccc      PARAMETER (mixq=.TRUE.)
+      PARAMETER (mixq=.FALSE.)
+c
+      REAL zh(klon,klev)
+      REAL zho(klon,klev)
+      REAL zq(klon,klev)
+      REAL zpk(klon,klev)
+      REAL zpkdp(klon,klev)
+      REAL hm, sm, qm
+      LOGICAL modif(klon), down
+      INTEGER i, k, k1, k2
+c
+c Initialisation:
+c
+cym
+      limhau=klev
+  
+      DO k = 1, klev
+      DO i = 1, klon
+         d_t(i,k) = 0.0
+         d_q(i,k) = 0.0
+      ENDDO
+      ENDDO
+c------------------------------------- detection des profils a modifier
+      DO k = 1, limhau
+      DO i = 1, klon
+         zpk(i,k) = pplay(i,k)**RKAPPA
+         zh(i,k) = RCPD * t(i,k)/ zpk(i,k)
+         zho(i,k) = zh(i,k)
+         zq(i,k) = q(i,k)
+      ENDDO
+      ENDDO
+c
+      DO k = 1, limhau
+      DO i = 1, klon
+         zpkdp(i,k) = zpk(i,k) * (paprs(i,k)-paprs(i,k+1))
+      ENDDO
+      ENDDO
+c
+      DO i = 1, klon
+         modif(i) = .FALSE.
+      ENDDO
+      DO k = 2, limhau
+      DO i = 1, klon
+      IF (.NOT.modif(i).and.k-1>limbas(i)) THEN
+         IF ( zh(i,k).LT.zh(i,k-1) ) modif(i) = .TRUE.
+      ENDIF
+      ENDDO
+      ENDDO
+c------------------------------------- correction des profils instables
+      DO 1080 i = 1, klon
+      IF (modif(i)) THEN
+          k2 = limbas(i)
+ 8000     CONTINUE
+            k2 = k2 + 1
+            IF (k2 .GT. limhau) goto 8001
+            IF (zh(i,k2) .LT. zh(i,k2-1)) THEN
+              k1 = k2 - 1
+              k = k1
+              sm = zpkdp(i,k2)
+              hm = zh(i,k2)
+              qm = zq(i,k2)
+ 8020         CONTINUE
+                sm = sm +zpkdp(i,k)
+                hm = hm +zpkdp(i,k) * (zh(i,k)-hm) / sm
+                qm = qm +zpkdp(i,k) * (zq(i,k)-qm) / sm
+                down = .FALSE.
+                IF (k1 .ne. limbas(i)) THEN
+                  IF (hm .LT. zh(i,k1-1)) down = .TRUE.
+                ENDIF
+                IF (down) THEN
+                  k1 = k1 - 1
+                  k = k1
+                ELSE
+                  IF ((k2 .EQ. limhau)) GOTO 8021
+                  IF ((zh(i,k2+1).GE.hm)) GOTO 8021
+                  k2 = k2 + 1
+                  k = k2
+                ENDIF
+              GOTO 8020
+ 8021         CONTINUE
+c------------ nouveau profil : constant (valeur moyenne)
+              DO k = k1, k2
+                zh(i,k) = hm
+                zq(i,k) = qm
+              ENDDO
+              k2 = k2 + 1
+            ENDIF
+          GOTO 8000
+ 8001     CONTINUE
+      ENDIF
+ 1080 CONTINUE
+c
+      DO k = 1, limhau
+      DO i = 1, klon
+         d_t(i,k) = (zh(i,k)-zho(i,k))*zpk(i,k)/RCPD
+         d_q(i,k) = zq(i,k) - q(i,k)
+      ENDDO
+      ENDDO
+c
+! FH : les d_q et d_t sont maintenant calcules de facon a valoir
+! effectivement 0. si on ne fait rien.
+!
+!     IF (limbas.GT.1) THEN
+!     DO k = 1, limbas-1
+!     DO i = 1, klon
+!        d_t(i,k) = 0.0
+!        d_q(i,k) = 0.0
+!     ENDDO
+!     ENDDO
+!     ENDIF
+c
+!     IF (limhau.LT.klev) THEN
+!     DO k = limhau+1, klev
+!     DO i = 1, klon
+!        d_t(i,k) = 0.0
+!        d_q(i,k) = 0.0
+!     ENDDO
+!     ENDDO
+!     ENDIF
+c
+      IF (.NOT.mixq) THEN
+      DO k = 1, klev
+      DO i = 1, klon
+         d_q(i,k) = 0.0
+      ENDDO
+      ENDDO
+      ENDIF
+c
+      RETURN
+      END
+
+      SUBROUTINE ajsec_convV2(paprs, pplay, t,q, d_t,d_q)
       USE dimphy
       IMPLICIT none
Index: LMDZ4/trunk/libf/phylmd/calltherm.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/calltherm.F90	(revision 878)
+++ LMDZ4/trunk/libf/phylmd/calltherm.F90	(revision 878)
@@ -0,0 +1,291 @@
+!
+! $Header$
+!
+      subroutine calltherm(dtime  &
+     &      ,pplay,paprs,pphi,weak_inversion  &
+     &      ,u_seri,v_seri,t_seri,q_seri,zqsat,debut  &
+     &      ,d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs  &
+     &      ,fm_therm,entr_therm,zqasc,clwcon0,lmax,ratqscth,  &
+     &       ratqsdiff,zqsatth)
+
+      implicit none
+#include "dimensions.h"
+#include "dimphy.h"
+#include "thermcell.h"
+
+!  A inclure eventuellement dans les fichiers de configuration
+      data r_aspect_thermals,l_mix_thermals,tho_thermals/2.,30.,0./
+      data w2di_thermals/0/
+
+      REAL dtime
+      LOGICAL debut
+      REAL u_seri(klon,klev),v_seri(klon,klev)
+      REAL t_seri(klon,klev),q_seri(klon,klev),qmemoire(klon,klev)
+      REAL weak_inversion(klon)
+      REAL paprs(klon,klev+1)
+      REAL pplay(klon,klev)
+      REAL pphi(klon,klev)
+      real zlev(klon,klev+1) 
+
+!FH Update Thermiques
+      REAL d_t_ajs(klon,klev), d_q_ajs(klon,klev)
+      REAL d_u_ajs(klon,klev),d_v_ajs(klon,klev)
+      real fm_therm(klon,klev+1),entr_therm(klon,klev)
+
+!********************************************************
+!     declarations
+      real fmc_therm(klon,klev+1),zqasc(klon,klev)
+      real zqla(klon,klev)
+      real wmax_sec(klon)
+      real zmax_sec(klon)
+      real f_sec(klon)
+      real detrc_therm(klon,klev)
+      save fmc_therm, detrc_therm
+      real clwcon0(klon,klev)
+      real zqsat(klon,klev)
+      real zw_sec(klon,klev+1)
+      integer lmix_sec(klon)
+      integer lmax(klon)
+      real ratqscth(klon,klev)
+      real ratqsdiff(klon,klev)
+      real zqsatth(klon,klev)  
+!********************************************************
+
+
+! variables locales
+      REAL d_t_the(klon,klev), d_q_the(klon,klev)
+      REAL d_u_the(klon,klev),d_v_the(klon,klev)
+!
+      real zfm_therm(klon,klev+1),zentr_therm(klon,klev),zdt
+      save zentr_therm,zfm_therm
+
+      integer i,k
+
+!********************************************************
+
+!  Modele du thermique
+!  ===================
+!         print*,'thermiques: WARNING on passe t au lieu de t_seri'
+
+
+         fm_therm(:,:)=0.
+         entr_therm(:,:)=0.
+       print*,'thermV4 nsplit: ',nsplit_thermals,' weak_inversion'
+
+
+!   tests sur les valeurs negatives de l'eau
+         do k=1,klev
+            do i=1,klon
+               if (.not.q_seri(i,k).ge.0.) then
+                   print*,'WARN eau<0 avant therm i=',i,'  k=',k  &
+     &         ,' dq,q',d_q_the(i,k),q_seri(i,k)
+                  q_seri(i,k)=1.e-15
+               endif
+            enddo
+         enddo
+
+
+         zdt=dtime/float(nsplit_thermals)
+         do isplit=1,nsplit_thermals
+
+          if (iflag_thermals.eq.1) then
+            CALL thermcell_2002(klon,klev,zdt   &
+     &      ,pplay,paprs,pphi  &
+     &      ,u_seri,v_seri,t_seri,q_seri  &
+     &      ,d_u_the,d_v_the,d_t_the,d_q_the  &
+     &      ,zfm_therm,zentr_therm  &
+     &      ,r_aspect_thermals,30.,w2di_thermals  &
+     &      ,tho_thermals,3)
+          else if (iflag_thermals.eq.2) then
+            CALL thermcell_sec(klon,klev,zdt  &
+     &      ,pplay,paprs,pphi,zlev  &
+     &      ,u_seri,v_seri,t_seri,q_seri  &
+     &      ,d_u_the,d_v_the,d_t_the,d_q_the  &
+     &      ,zfm_therm,zentr_therm  &
+     &      ,r_aspect_thermals,30.,w2di_thermals  &
+     &      ,tho_thermals,3)
+          else if (iflag_thermals.eq.3) then
+            CALL thermcell(klon,klev,zdt  &
+     &      ,pplay,paprs,pphi  &
+     &      ,u_seri,v_seri,t_seri,q_seri  &
+     &      ,d_u_the,d_v_the,d_t_the,d_q_the  &
+     &      ,zfm_therm,zentr_therm  &
+     &      ,r_aspect_thermals,l_mix_thermals,w2di_thermals  &
+     &      ,tho_thermals,3)
+          else if (iflag_thermals.eq.10) then
+            CALL thermcell_eau(klon,klev,zdt  &
+     &      ,pplay,paprs,pphi  &
+     &      ,u_seri,v_seri,t_seri,q_seri  &
+     &      ,d_u_the,d_v_the,d_t_the,d_q_the  &
+     &      ,zfm_therm,zentr_therm  &
+     &      ,r_aspect_thermals,l_mix_thermals,w2di_thermals  &
+     &      ,tho_thermals,3)
+          else if (iflag_thermals.eq.11) then
+            stop'cas non prevu dans calltherm'
+!           CALL thermcell_pluie(klon,klev,zdt  &
+!   &      ,pplay,paprs,pphi,zlev  &
+!    &      ,u_seri,v_seri,t_seri,q_seri  &
+!    &      ,d_u_the,d_v_the,d_t_the,d_q_the  &
+!    &      ,zfm_therm,zentr_therm,zqla  &
+!    &      ,r_aspect_thermals,l_mix_thermals,w2di_thermals  &
+!    &      ,tho_thermals,3)
+          else if (iflag_thermals.eq.12) then
+            CALL calcul_sec(klon,klev,zdt  &
+     &      ,pplay,paprs,pphi,zlev  &
+     &      ,u_seri,v_seri,t_seri,q_seri  &
+     &      ,zmax_sec,wmax_sec,zw_sec,lmix_sec  &
+     &      ,r_aspect_thermals,l_mix_thermals,w2di_thermals  &
+     &      ,tho_thermals)
+!            CALL calcul_sec_entr(klon,klev,zdt
+!     s      ,pplay,paprs,pphi,zlev,debut
+!     s      ,u_seri,v_seri,t_seri,q_seri                
+!     s      ,zmax_sec,wmax_sec,zw_sec,lmix_sec
+!     s      ,r_aspect_thermals,l_mix_thermals,w2di_thermals
+!     s      ,tho_thermals,3)
+!           CALL thermcell_pluie_detr(klon,klev,zdt  &
+!    &      ,pplay,paprs,pphi,zlev,debut  &
+!    &      ,u_seri,v_seri,t_seri,q_seri  &
+!    &      ,d_u_the,d_v_the,d_t_the,d_q_the  &
+!    &      ,zfm_therm,zentr_therm,zqla,lmax  &
+!    &      ,zmax_sec,wmax_sec,zw_sec,lmix_sec  &
+!    &      ,ratqscth,ratqsdiff,zqsatth  &
+!    &      ,r_aspect_thermals,l_mix_thermals,w2di_thermals  &
+!    &      ,tho_thermals)
+          else if (iflag_thermals.ge.13) then
+            CALL thermcell_main(klon,klev,zdt  &
+     &      ,pplay,paprs,pphi,debut  &
+     &      ,u_seri,v_seri,t_seri,q_seri  &
+     &      ,d_u_the,d_v_the,d_t_the,d_q_the  &
+     &      ,zfm_therm,zentr_therm,zqla,lmax  &
+     &      ,ratqscth,ratqsdiff,zqsatth  &
+     &      ,r_aspect_thermals,l_mix_thermals,w2di_thermals  &
+     &      ,tho_thermals)
+         endif
+
+
+      DO i=1,klon
+      DO k=1,klev
+            IF(iflag_thermals.lt.14.or.weak_inversion(i).gt.0.5) THEN
+
+!  transformation de la derivee en tendance
+            d_t_the(i,k)=d_t_the(i,k)*dtime/float(nsplit_thermals)
+            d_u_the(i,k)=d_u_the(i,k)*dtime/float(nsplit_thermals)
+            d_v_the(i,k)=d_v_the(i,k)*dtime/float(nsplit_thermals)
+            d_q_the(i,k)=d_q_the(i,k)*dtime/float(nsplit_thermals)
+            fm_therm(i,k)=fm_therm(i,k)  &
+     &      +zfm_therm(i,k)/float(nsplit_thermals)
+            entr_therm(i,k)=entr_therm(i,k)  &
+     &       +zentr_therm(i,k)/float(nsplit_thermals)
+            fm_therm(:,klev+1)=0.
+
+
+
+!  accumulation de la tendance
+            d_t_ajs(i,k)=d_t_ajs(i,k)+d_t_the(i,k)
+            d_u_ajs(i,k)=d_u_ajs(i,k)+d_u_the(i,k)
+            d_v_ajs(i,k)=d_v_ajs(i,k)+d_v_the(i,k)
+            d_q_ajs(i,k)=d_q_ajs(i,k)+d_q_the(i,k)
+
+!  incrementation des variables meteo
+            t_seri(i,k) = t_seri(i,k) + d_t_the(i,k)
+            u_seri(i,k) = u_seri(i,k) + d_u_the(i,k)
+            v_seri(i,k) = v_seri(i,k) + d_v_the(i,k)
+            qmemoire(i,k)=q_seri(i,k)
+            q_seri(i,k) = q_seri(i,k) + d_q_the(i,k)
+           ENDIF
+       ENDDO
+       ENDDO
+
+!   tests sur les valeurs negatives de l'eau
+            DO k = 1, klev
+            DO i = 1, klon
+               if (.not.q_seri(i,k).ge.0.) then
+                   print*,'WARN eau<0 apres therm i=',i,'  k=',k  &
+     &         ,' dq,q',d_q_the(i,k),q_seri(i,k),  &
+     &         'fm=',zfm_therm(i,k),'entr=',entr_therm(i,k)
+                  q_seri(i,k)=1.e-15
+!       stop
+               endif
+            ENDDO
+            ENDDO
+! tests sur les valeurs de la temperature
+            DO k = 1, klev
+            DO i = 1, klon
+               if ((t_seri(i,k).lt.50.) .or.  &
+     &              (t_seri(i,k).gt.370.)) then
+                  print*,'WARN temp apres therm i=',i,'  k=',k  &
+     &         ,' t_seri',t_seri(i,k)
+!              CALL abort
+               endif
+            ENDDO
+            ENDDO
+
+         enddo ! isplit
+
+!
+!***************************************************************
+!     calcul du flux ascencant conservatif
+!            print*,'<<<<calcul flux ascendant conservatif'
+
+      fmc_therm=0.
+               do k=1,klev
+            do i=1,klon
+                  if (entr_therm(i,k).gt.0.) then
+                     fmc_therm(i,k+1)=fmc_therm(i,k)+entr_therm(i,k)
+                  else
+                     fmc_therm(i,k+1)=fmc_therm(i,k)
+                  endif
+                  detrc_therm(i,k)=(fmc_therm(i,k+1)-fm_therm(i,k+1))  &
+     &                 -(fmc_therm(i,k)-fm_therm(i,k))
+               enddo
+            enddo
+      
+     
+!****************************************************************
+!     calcul de l'humidite dans l'ascendance
+!      print*,'<<<<calcul de lhumidite dans thermique'
+!CR:on ne le calcule que pour le cas sec
+      if (iflag_thermals.le.11) then      
+      do i=1,klon
+         zqasc(i,1)=q_seri(i,1)
+         do k=2,klev
+            if (fmc_therm(i,k+1).gt.1.e-6) then
+               zqasc(i,k)=(fmc_therm(i,k)*zqasc(i,k-1)  &
+     &              +entr_therm(i,k)*q_seri(i,k))/fmc_therm(i,k+1)
+!CR:test on asseche le thermique
+!               zqasc(i,k)=zqasc(i,k)/2.
+!            else
+!               zqasc(i,k)=q_seri(i,k)
+            endif
+         enddo
+       enddo
+      
+
+!     calcul de l'eau condensee dans l'ascendance
+!             print*,'<<<<calcul de leau condensee dans thermique'
+             do i=1,klon
+                do k=1,klev
+                   clwcon0(i,k)=zqasc(i,k)-zqsat(i,k)
+                   if (clwcon0(i,k).lt.0. .or.   &
+     &             (fm_therm(i,k+1)+detrc_therm(i,k)).lt.1.e-6) then
+                      clwcon0(i,k)=0.
+                   endif
+                enddo
+             enddo
+       else
+              do i=1,klon
+                do k=1,klev
+                   clwcon0(i,k)=zqla(i,k)  
+                   if (clwcon0(i,k).lt.0. .or.   &
+     &             (fm_therm(i,k+1)+detrc_therm(i,k)).lt.1.e-6) then
+                   clwcon0(i,k)=0. 
+                   endif
+                enddo
+             enddo
+       endif
+!*******************************************************************    
+
+
+      return
+
+      end
Index: LMDZ4/trunk/libf/phylmd/clouds_gno.F
===================================================================
--- LMDZ4/trunk/libf/phylmd/clouds_gno.F	(revision 868)
+++ LMDZ4/trunk/libf/phylmd/clouds_gno.F	(revision 878)
@@ -219,5 +219,17 @@
 c -- test numerical convergence:
 
-c         print*,'avant test ',i,k,lconv(i),u(i),v(i)
+          if (beta(i).lt.1.e-10) then
+              print*,'avant test ',i,k,lconv(i),u(i),v(i),beta(i)
+              stop
+          endif
+          if (abs(fprime(i)).lt.1.e-11) then
+              print*,'avant test fprime<.e-11 '
+     s        ,i,k,lconv(i),u(i),v(i),beta(i),fprime(i)
+              print*,'klon,ND,R,RS,QSUB',
+     s        klon,ND,R(i,k),rs(i,k),qsub(i,k)
+              fprime(i)=sign(1.e-11,fprime(i))
+          endif
+
+
           if ( ABS(dist(i)/beta(i)) .LT. epsilon ) then 
 c           print*,'v-u **2',(v(i)-u(i))**2
Index: LMDZ4/trunk/libf/phylmd/coef_diff_turb_mod.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/coef_diff_turb_mod.F90	(revision 868)
+++ LMDZ4/trunk/libf/phylmd/coef_diff_turb_mod.F90	(revision 878)
@@ -18,5 +18,5 @@
   SUBROUTINE coef_diff_turb(dtime, nsrf, knon, ni, &
        ypaprs, ypplay, yu, yv, yq, yt, yts, yrugos, yqsurf, &
-       ycoefm, ycoefh)
+       ycoefm, ycoefh ,yq2)
 ! 
 ! Calculate coefficients(ycoefm, ycoefh) for turbulent diffusion in the 
@@ -35,4 +35,5 @@
     REAL, DIMENSION(klon,klev), INTENT(IN)     :: yq, yt
     REAL, DIMENSION(klon), INTENT(IN)          :: yts, yrugos, yqsurf
+    REAL, DIMENSION(klon,klev+1)               :: yq2
   
 ! Output arguments
@@ -41,16 +42,9 @@
     REAL, DIMENSION(klon,klev), INTENT(OUT)    :: ycoefm
 
-! Local variables with attribute SAVE
-!****************************************************************************************
-    REAL, DIMENSION(:,:,:), ALLOCATABLE, SAVE  :: q2save
-    !$OMP THREADPRIVATE(q2save)
-    LOGICAL, SAVE                              :: first_call=.TRUE.
-    !$OMP THREADPRIVATE(first_call)    
-
 ! Other local variables
 !****************************************************************************************
     INTEGER                                    :: k, i, j
     REAL, DIMENSION(klon,klev)                 :: ycoefm0, ycoefh0, yzlay, yteta
-    REAL, DIMENSION(klon,klev+1)               :: yzlev, yq2, q2diag, ykmm, ykmn, ykmq
+    REAL, DIMENSION(klon,klev+1)               :: yzlev, q2diag, ykmm, ykmn, ykmq
     REAL, DIMENSION(klon)                      :: y_cd_h, y_cd_m
     REAL, DIMENSION(klon)                      :: yustar
@@ -94,5 +88,5 @@
             ycoefm0, ycoefh0)
 
-       DO k = 1, klev
+       DO k = 2, klev
           DO i = 1, knon
              ycoefm(i,k) = MAX(ycoefm(i,k),ycoefm0(i,k))
@@ -121,5 +115,5 @@
             ycoefm0,ycoefh0)
        
-       DO k = 1, klev
+       DO k = 2, klev
           DO i = 1, knon
              ycoefm(i,k) = MAX(ycoefm(i,k),ycoefm0(i,k))
@@ -137,12 +131,4 @@
 
     IF (iflag_pbl.GE.3) THEN
-
-       IF (first_call) THEN
-          PRINT*, "Using method MELLOR&YAMADA"
-          ! NB! q2save could/should be read and written from (re)startphy.nc
-          ALLOCATE(q2save(klon,klev+1,nbsrf))
-          q2save(:,:,:) = 1.e-8
-          first_call=.FALSE.
-       END IF
 
        yzlay(1:knon,1)= &
@@ -173,21 +159,13 @@
        END DO
 
-! Compresse q2save
-       DO k = 1, klev+1
-          DO j = 1, knon
-             i = ni(j)
-             yq2(j,k)=q2save(i,k,nsrf)
-          ENDDO
-       ENDDO
-         
-!   Bug introduit volontairement pour converger avec les resultats
-!   du papier sur les thermiques.
-       IF (1.EQ.1) THEN
-          y_cd_m(1:knon) = ycoefm(1:knon,1)
-          y_cd_h(1:knon) = ycoefh(1:knon,1)
-       ELSE
-          y_cd_h(1:knon) = ycoefm(1:knon,1)
-          y_cd_m(1:knon) = ycoefh(1:knon,1)
-       ENDIF
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! Pour memoire, le papier Hourdin et al. 2002 a ete obtenur avec un
+! bug sur les coefficients de surface :
+!          y_cd_h(1:knon) = ycoefm(1:knon,1)
+!          y_cd_m(1:knon) = ycoefh(1:knon,1)
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+       y_cd_m(1:knon) = ycoefm(1:knon,1)
+       y_cd_h(1:knon) = ycoefh(1:knon,1)
        
        CALL ustarhb(knon,yu,yv,y_cd_m, yustar)
@@ -215,12 +193,4 @@
        ycoefh(1:knon,2:klev)=ykmn(1:knon,2:klev)
                 
-! update q2save with yq2
-       DO j=1,knon
-          DO k=1,klev+1
-             i=ni(j)
-             q2save(i,k,nsrf) = yq2(j,k)
-          END DO
-       END DO
-       
     ENDIF !(iflag_pbl.ge.3)
 
Index: LMDZ4/trunk/libf/phylmd/conf_phys.F90
===================================================================
--- LMDZ4/trunk/libf/phylmd/conf_phys.F90	(revision 868)
+++ LMDZ4/trunk/libf/phylmd/conf_phys.F90	(revision 878)
@@ -6,7 +6,7 @@
 
   subroutine conf_phys(ocean, ok_veget, ok_journe, ok_mensuel, ok_instan, ok_hf, &
+ &                     seuil_inversion, &
  &                     fact_cldcon, facttemps,ok_newmicro,iflag_cldcon, &
-!IM&                   ratqsbas,ratqshaut,ip_ebil_phy, &
- &                     ratqsbas,ratqshaut, &
+ &                     iflag_ratqs,ratqsbas,ratqshaut, &
  &		       ok_ade, ok_aie, &
  &                     bl95_b0, bl95_b1,&
@@ -51,4 +51,5 @@
   real                 :: fact_cldcon, facttemps,ratqsbas,ratqshaut
   integer              :: iflag_cldcon
+  integer              :: iflag_ratqs
 
   character (len = 6),SAVE  :: ocean_omp
@@ -61,8 +62,12 @@
   real,SAVE           :: ratqshaut_omp
   integer,SAVE        :: iflag_cldcon_omp, ip_ebil_phy_omp
+  integer,SAVE        :: iflag_ratqs_omp
 
 ! Local
   integer              :: numout = 6
   real                 :: zzz
+
+  real :: seuil_inversion
+  real,save :: seuil_inversion_omp
 
   integer :: iflag_thermals,nsplit_thermals
@@ -82,5 +87,5 @@
   REAL,SAVE :: cdmmax_omp,cdhmax_omp,ksta_omp,ksta_ter_omp
   LOGICAL,SAVE :: ok_kzmin_omp
-  REAL, SAVE ::  fmagic_omp
+  REAL, SAVE :: fmagic_omp
   INTEGER,SAVE :: iflag_pbl_omp,lev_histhf_omp,lev_histday_omp,lev_histmth_omp
   CHARACTER*4, SAVE :: type_run_omp
@@ -207,7 +212,15 @@
 !Config Help = 
 !               
-!
   ip_ebil_phy_omp = 0
   call getin('ip_ebil_phy', ip_ebil_phy_omp)
+!
+!Config Key  = seuil_inversion
+!Config Desc = Seuil ur dTh pour le choix entre les schemas de CL
+!Config Def  = -0.1
+!Config Help = 
+!               
+  seuil_inversion_omp = -0.1
+  call getin('seuil_inversion', seuil_inversion_omp)
+
 !!
 !! Constante solaire & Parametres orbitaux & taux gaz effet de serre BEG
@@ -438,4 +451,13 @@
   reevap_ice_omp = .false.
   call getin('reevap_ice',reevap_ice_omp)
+
+!Config Key  = iflag_ratqs
+!Config Desc =
+!Config Def  = 1
+!Config Help =
+!
+  iflag_ratqs_omp = 1
+  call getin('iflag_ratqs',iflag_ratqs_omp)
+
 !
 !Config Key  = iflag_cldcon 
@@ -835,4 +857,5 @@
     ratqshaut = ratqshaut_omp
     iflag_cldcon = iflag_cldcon_omp
+    iflag_ratqs = iflag_ratqs_omp
     ip_ebil_phy = ip_ebil_phy_omp
     iflag_thermals = iflag_thermals_omp
@@ -840,4 +863,5 @@
     type_run = type_run_omp
     ok_isccp = ok_isccp_omp
+    seuil_inversion=seuil_inversion_omp
     lonmin_ins = lonmin_ins_omp
     lonmax_ins = lonmax_ins_omp
@@ -891,4 +915,6 @@
   write(numout,*)' iflag_pdf = ', iflag_pdf
   write(numout,*)' iflag_cldcon = ', iflag_cldcon
+  write(numout,*)' iflag_ratqs = ', iflag_ratqs
+  write(numout,*)' seuil_inversion = ', seuil_inversion
   write(numout,*)' fact_cldcon = ', fact_cldcon
   write(numout,*)' facttemps = ', facttemps
Index: LMDZ4/trunk/libf/phylmd/dimphy.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/dimphy.h	(revision 868)
+++ LMDZ4/trunk/libf/phylmd/dimphy.h	(revision 878)
@@ -2,12 +2,12 @@
 ! $Header$
 !
-c-----------------------------------------------------------------------
+!-----------------------------------------------------------------------
       INTEGER KIDIA, KFDIA, KLON, KLEV
-      PARAMETER (KIDIA=1,KFDIA=iim*(jjm-1)+2-1/jjm,
-     .           KLON=KFDIA-KIDIA+1,KLEV=llm)
-c-----------------------------------------------------------------------
+      PARAMETER (KIDIA=1,KFDIA=iim*(jjm-1)+2-1/jjm)
+      PARAMETER (KLON=KFDIA-KIDIA+1,KLEV=llm)
+!-----------------------------------------------------------------------
       INTEGER nbtr ! nombre de vrais traceurs
       PARAMETER (nbtr=nqmx-2+1/(nqmx-1))
-c-----------------------------------------------------------------------
+!-----------------------------------------------------------------------
       REAL zmasq(KLON)
       COMMON/terreoce/zmasq
Index: LMDZ4/trunk/libf/phylmd/ini_histday.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/ini_histday.h	(revision 868)
+++ LMDZ4/trunk/libf/phylmd/ini_histday.h	(revision 878)
@@ -53,4 +53,13 @@
 c Champs 2D:
 c
+         CALL histdef(nid_day, "weakinv", "Weak inversion", "",
+     s           iim,jjmp1,nhori, 1,1,1, -99, 32,
+     s           "ave(X)", zstophy,zout)
+
+         CALL histdef(nid_day, "dthmin", "dTheta mini", "K/m",
+     s           iim,jjmp1,nhori, 1,1,1, -99, 32,
+     s           "ave(X)", zstophy,zout)
+
+
          CALL histdef(nid_day, "tsol", "Surface Temperature", "K",
      .                iim,jj_nb,nhori, 1,1,1, -99, 32, 
@@ -538,4 +547,20 @@
      $         "ave(X)", zstophy,zout)
 C
+
+
+! FH Sorties specifiques pour Mellor et Yamada
+      if (iflag_pbl>1 .and. lev_histday.gt.10 ) then
+           call histdef(nid_day, "tke_"//clnsurf(nsrf), 
+     $         "Max Turb. Kinetic Energy "//clnsurf(nsrf), "-",  
+     $         iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     $         "ave(X)", zstophy,zout)
+
+           call histdef(nid_day, "tke_max_"//clnsurf(nsrf), 
+     $         "Max Turb. Kinetic Energy "//clnsurf(nsrf), "-",  
+     $         iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     $         "t_max(X)", zstophy,zout)
+      endif	
+
+C
          END DO 
 C           
Index: LMDZ4/trunk/libf/phylmd/ini_histmth.h
===================================================================
--- LMDZ4/trunk/libf/phylmd/ini_histmth.h	(revision 868)
+++ LMDZ4/trunk/libf/phylmd/ini_histmth.h	(revision 878)
@@ -700,4 +700,24 @@
       IF(lev_histmth.GE.4) THEN
 c
+!FH Sorties pour la couche limite
+      if (iflag_pbl>1) then
+         CALL histdef(nid_mth, "tke","TKE","m2/s2",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zstophy,zout)
+c
+         CALL histdef(nid_mth, "tke_max","TKE max","m2/s2",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "t_max(X)", zstophy,zout)
+      endif
+c
+         CALL histdef(nid_mth, "kz","Kz melange","m2/s",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zstophy,zout)
+c
+         CALL histdef(nid_mth, "kz_max","Kz melange max","m2/s",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "t_max(X)", zstophy,zout)
+
+
          CALL histdef(nid_mth, "clwcon", 
      .                "Convective Cloud Liquid water content"
@@ -730,4 +750,7 @@
      .                "ave(X)", zstophy,zout)
 c
+
+
+c
 c        CALL histdef(nid_mth, "ducon", "Convection du", "m/s2",
 c    .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
@@ -774,4 +797,12 @@
      .                "ave(X)", zstophy,zout)
 
+c
+         CALL histdef(nid_mth, "dtthe", "Dry adjust. dT", "K/s",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zstophy,zout)
+
+         CALL histdef(nid_mth,"dqthe","Dry adjust. dQ","(kg/kg)/s",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zstophy,zout)
 c
          CALL histdef(nid_mth, "dtajs", "Dry adjust. dT", "K/s",
@@ -879,10 +910,10 @@
          if (nqmax.GE.3) THEN
            DO iq=3,nqmax
-           iiq=niadv(iq)
+             iiq=niadv(iq)
              CALL histdef(nid_mth, tnom(iq), ttext(iiq), "-",
      .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zstophy,zout)
-           ENDDO
-         ENDIF
+             ENDDO
+           ENDIF
 #endif
 c
@@ -960,4 +991,12 @@
 c
           CALL histdef(nid_mth, "dtcon","dtcon","K/s",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zstophy,zout)
+c
+         CALL histdef(nid_mth, "dtthe", "Dry adjust. dT", "K/s",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zstophy,zout)
+
+         CALL histdef(nid_mth,"dqthe","Dry adjust. dQ","(kg/kg)/s",
      .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
      .                "ave(X)", zstophy,zout)
@@ -1668,4 +1707,26 @@
       IF(lev_histmth.GE.4) THEN
 c
+!FH Sorties pour la couche limite
+      if (iflag_pbl>1) then
+         CALL histdef(nid_mth, "tke","TKE","m2/s2",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zstophy,zout)
+c
+         CALL histdef(nid_mth, "tke_max","TKE max","m2/s2",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "t_max(X)", zstophy,zout)
+      endif
+c
+         CALL histdef(nid_mth, "kz","Kz melange","m2/s",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zstophy,zout)
+c
+         CALL histdef(nid_mth, "kz_max","Kz melange max","m2/s",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "t_max(X)", zstophy,zout)
+
+
+
+
          CALL histdef(nid_mth, "clwcon", 
      .                "Convective Cloud Liquid water content"
@@ -1831,11 +1892,11 @@
 #ifndef INCA
          if (nqmax.GE.3) THEN
-           DO iq=3,nqmax
-             iiq=niadv(iq)
-             CALL histdef(nid_mth, tnom(iq), ttext(iiq), "-",
-     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
-     .                "ave(X)", zstophy,zout)
-             ENDDO
-           ENDIF
+         DO iq=3,nqmax
+         iiq=niadv(iq)
+         CALL histdef(nid_mth, tnom(iq), ttext(iiq), "-",
+     .                iim,jj_nb,nhori, klev,1,klev,nvert, 32,
+     .                "ave(X)", zstophy,zout)
+         ENDDO
+         ENDIF
 #endif
 
